  ' Sottoprogrammi
  ' --------------
  ' stampa: Stampa un testo in formato ASM (cambiare valore di DE se necessario)
  ' premitasto: Mostra il messaggio premi$ e mette il gioco in pausa finché non si preme un tasto
  ' nofondi: Stampa l'avviso "fondi insufficienti"
  ' nopiloti: Stampa l'avviso "non ci sono piloti"
  ' nostru: Stampa l'avviso "struttura necessaria"
  ' lista: Stampa una lista di numeri per le opzioni. Parametri: lin,col = coordinate iniziali; pun = numero di punti
  ' pulisci: Pulisce le righe da 2 a 21
  ' inp: Inserisce un valore numerico. Il valore è conservato in i
  ' conferma: Conferma/annulla
  ' cancerig: Cancella le ultime tre righe dello schermo
  ' costoricerca: Mostra i costi e la situazione della ricerca
  ' bonusric: Assegna un bonus una tantum all'inizio della ricerca se il materiale precedente è già stato sviluppato al massimo
  ' elenpilo: Stampa l'elenco dei piloti
  ' addest: Procedura addestramento piloti
  ' intemis: Stampa l'intestazione della pianificazione missioni
  ' riepmis: Rivedi tutti i dati della missione. x è il numero identificativo della missione e va specificato prima di richiamare il sottoprogramma
  ' stampaeff: Stampa l'efficienza totale della missione. Specificare x prima di richiamare
  ' azzemis: Azzera i parametri della missione in caso di annullamento o di completamento
  ' controllo: Confronta l'efficienza attuale del materiale e la relativa abilità del pilota con un numero pseudocasuale tra 1 e 99
  ' problema: Determina l'inconveniente e stampa il messaggio relativo
  ' salvezza: In caso di problema determina la sorte dell'equipaggio
  ' calcbonabi: Calcola il bonus abilità
  ' malfunz: Determina il tipo di inconveniente in base al materiale e stampa il relativo messaggio
  ' pilorand: Sceglie un pilota a caso e ne inserisce il numero (10-13) in q
  ' piloferito: Stampa il messaggio di pilota ferito, ne cambia lo status e diminuisce il prestigio
  ' pilomorto: Stampa il messaggio di pilota morto, ne cambia lo status e diminuisce il prestigio
  ' punteggio: Calcola e mostra il punteggio finale
  ' efficienza: Aumenta di 1 l'efficienza del materiale fino al massimo possibile
  ' notizia: Stampa l'avviso "notizia flash" e controlla se gli avversari hanno raggiunto una pietra miliare
  ' cancepilo: Cancella i piloti dalla missione in corso di programmazione
  ' necessita: Stampa l'avviso "Questa missione necessita di:"
  ' progcaso: Sceglie un programma di ricerca a caso
  ' inno: Inni nazionali
  ' veripilo: Verifica se i piloti hanno le abilità richieste dalla missione
  ' noab: Stampa l'avviso "selezione non valida" e torna alla scelta dell'equipaggio
  ' stampafondi: Stampa la quantità di fondi a 16,1
  ' Funzioni per il calcolo dei coefficienti pseudo-casuali (Britlion, Patrik Rak)

  ' Stampa un testo in formato ASM (cambiare valore di DE se necessario)

SUB FASTCALL stampa()
ASM
  
  ; LD DE,(25022)    ; se il programma comincia a 25000
  LD DE,(24622)

STAMPA:
  PUSH DE            ; conserva l'indirizzo del messaggio
  LD A,2             ; parte superiore
  CALL 5633          ; apri il canale
  POP DE             ; riprendi l'indirizzo del messaggio...

STAMPA_MESS:
  LD A,(DE)          ; seleziona il carattere da stampare
  INC DE             ; punta al prossimo carattere
  CP 255             ; 255 = fine del testo
  JR Z, FINE         ; in tal caso, ritorna
  RST 16             ; stampa
  JR STAMPA_MESS     ; prosegui fino alla fine

FINE:
  
END ASM
END SUB

  ' Mostra il messaggio premi$ e mette il gioco in pausa finché non si preme un tasto

SUB premitasto()

  FLASH 0: PRINT AT 22,8; "\{p3}\{i7} PULSE UNA TECLA ": INK 0: PAUSE 0

END SUB

  ' Stampa l'avviso "fondi insufficienti"

SUB nofondi()

  CLS
  POKE UINTEGER indir,@nofond
  stampa()
  premitasto()

END SUB

  ' Stampa l'avviso "nessun pilota disponibile"

SUB nopiloti()

  CLS
  POKE UINTEGER indir,@nopilo
  stampa()
  premitasto()

END SUB

  ' Stampa l'avviso "struttura necessaria"

SUB nostru()

  CLS
  POKE UINTEGER indir,@strunec
  stampa()
  premitasto()

END SUB

  ' Stampa una lista di numeri per le opzioni.
  ' Parametri: lin,col = coordinate iniziali; pun = numero di punti

SUB lista(lin AS UBYTE, col AS UBYTE, pun AS UBYTE)

  n = 1
  DO
    PRINT at lin,col; PAPER naz; INK 7; " ";n;" "
	lin = lin + 2
	n = n + 1
  LOOP UNTIL n > pun

  PRINT AT lin+1,col+4; "VOLVER"; AT lin+1,col; PAPER naz; "\{i7} 0 "

END SUB

  ' Pulisce le righe da 2 a 21

SUB pulisci()
  
  n = 2
  DO
    PRINT AT n,0; rigav$
	n = n + 1
  LOOP UNTIL n = 22

END SUB

  ' Inserisce un valore numerico. Il valore è conservato in i

SUB inp()

   v$=""
   cancerig()
   PRINT AT 21,2; "OPCIoN: "; "\{f1} "; "\{f0}  "

10 PAUSE 0
   
   IF CODE INKEY$ = 13 THEN GOTO 20
   IF CODE INKEY$ = 12 AND LEN v$ > 0 THEN v$ = v$(TO LEN (v$)-1) :	 GOTO 15
   IF CODE INKEY$ < 48 OR CODE INKEY$ > 57 THEN GOTO 10
   IF LEN v$ < 2 THEN v$ = v$+INKEY$
   
15 PRINT AT 21,10; v$; "\{f1} "; "\{f0} "
   GOTO 10

20 IF v$ = "" THEN GOTO 10

   cancerig()
   i = VAL(v$) 

END SUB

  ' Conferma/annulla

SUB conferma()

  PRINT AT 21,8; "CONFIRMAR"; AT 23,8; "CANCELAR"; AT 21,4; PAPER naz; sce1$; AT 23,4; sce0$

attendiconf:

  PAUSE 0

  IF INKEY$ = "1" THEN LET k = 1: GOTO esci
  IF INKEY$ = "0" THEN LET k = 0: GOTO esci
 
  GOTO attendiconf

esci:

  cancerig()

END SUB

  ' Cancella le ultime tre righe dello schermo

SUB cancerig()

  n = 21
  DO
    PRINT AT n,0; rigav$
    n = n + 1
 LOOP UNTIL n = 24

END SUB

  ' Mostra i costi e la situazione della ricerca

SUB costoricerca()

  POKE UINTEGER indir,@costoric
  stampa()

  PRINT AT 5,18; costoini(x); AT 6,11; rsmax(x);"%"; AT 7,12; effmax(x);"%"; AT 8,13; rsatt(x);"%"; AT 9,14; effatt(x);"%"; AT 10,20; costors(x)

  stampafondi()

END SUB

  ' Assegna un bonus una tantum all'inizio della ricerca se il materiale precedente è già stato sviluppato al massimo

SUB bonusric()

  q = x-1

  IF rsatt(x) = 0 AND rsatt(q) = rsmax(q) THEN rsatt(x) = 20 : effatt(x) = 20

END SUB

  ' Stampa l'elenco dei piloti

SUB elenpilo()

  CLS
  
  k = 2
  n = 1

  DO 
    IF pilost$(n) = "N" OR pilost$(n) = "X" THEN GOTO nessuno
    PRINT AT k,1; n; "."; pilo$(n); AT k,15; abi(1,n); AT k,18; abi(2,n); AT k,21; abi(3,n); AT k,24; abi(4,n); AT k,27; abi(5,n); AT k,30; pilost$(n)
    k = k + 1
nessuno:
    n = n + 1
  LOOP UNTIL n = 11

  ' Se k rimane invariato non ci sono piloti

  IF k = 2 THEN
    CLS
    POKE UINTEGER indir,@noncisono
    stampa()
    premitasto()
  ELSE
    PRINT INK naz; AT 0,15;"PB EV AT PA RS ES"
  END IF

END SUB

  ' Procedura addestramento piloti

SUB addest()

  CLS

  ' Determina quale abilità stiamo addestrando (1-5)

  w = abi(7,n)

  ' Scala di 1 il numero di turni necessari all'addestramento

  abi(6,n) = abi(6,n) - 1

  ' Se l'addestramento non è ancora finito esce

  IF abi(6,n) > 0 THEN PRINT AT 8,1; "\{i0}\{p6}TURNOS: ";abi(6,n); AT 1,8; PAPER naz; "\{i7} ENTRENAMIENTO ": GOTO esci3

  ' Calcola il risultato dell'addestramento

  randomBase()
  rand = randomLimit(4)+1

  abi(w,n) = abi(w,n) + rand

  ' Massimo livello 9

  IF abi(w,n) > 9 THEN abi(w,n) = 9

  ' Stampa il risultato

  PRINT AT 1,2; PAPER naz; "\{i7} RESULTADO DEL ENTRENAMIENTO "

  ' Marca il pilota nuovamente come disponibile

  pilost$(n) = "D"
 
esci3:

  PRINT AT 4,1; pilo$(n); AT 6,2; abl$(w); ": "; abi(w,n)

  premitasto()

END SUB

  ' Stampa l'intestazione della pianificazione missioni

SUB intemis()

 pulisci()

 PRINT INK naz; AT 3,17;"CNT"; AT 3,21; "MAS"; AT 3,25; "EFC"

END SUB

  ' Rivedi tutti i dati della missione.
  ' x è il numero identificativo della missione e va specificato prima di richiamare il sottoprogramma

SUB riepmis()
  
  CLS

  ' k indica la riga dove stampare

  k = 7  

  IF miss(2,x) = 1 THEN v$ = "oRB.TERRESTRE"
  IF miss(2,x) = 2 THEN v$ = "oRB.LUNAR"
  IF miss(2,x) = 3 THEN v$ = "ATERR.LUNAR"

  ' Mostra veicolo, destinazione, vettore ed eventuale potenziamento

  POKE UINTEGER indir,@riepil
  stampa()
  w = miss(1,x): PRINT AT 3,11; mate$(w); AT 4,11;v$
  w = miss(4,x): PRINT AT 5,11; mate$(w)
  IF miss(5,x) = 1 THEN
    v$ = "Sl"
  ELSE
    v$ = "NO"
  END IF
  PRINT AT 6,11; v$; AT 1,7; PAPER naz; "\{i7} RESUMEN MISIoN "; x; " "

  ' Modulo lunare sì/no

checklem:

  w = miss(3,x)

  ' Modulo lunare non presente

  IF w = 0 THEN GOTO checkms

  ' Modulo lunare presente

  v$ = mate$(w)
  PRINT AT k,1; "MOD.LUNAR: "; v$
  
  ' Passa alla riga successiva

  k = k + 1

  ' Modulo di servizio sì/no

checkms:

  ' Modulo di servizio non presente

  IF miss(6,x) = 0 AND miss(7,x) = 0 THEN GOTO checkagga
  IF miss(6,x) = 1 THEN v$ = "A"
  IF miss(7,x) = 1 THEN v$ = "B"
  PRINT AT k,1; "MoD.SER.: "; v$

  ' Passa alla riga successiva

  k = k + 1

  ' Modulo di aggancio sì/no

checkagga:

  ' Modulo aggancio non presente

  IF miss(8,x) = 0 THEN GOTO checktute

  ' Modulo aggancio presente

  PRINT AT k,1; mate$(11)
 
  ' Passa alla riga successiva

  k = k + 1

  ' Tute AEV sì/no

checktute:

  w = miss(9,x)

  ' Tuta AEV non presente

  IF w = 0 THEN GOTO checkequi

  ' Tuta AEV presente

  PRINT AT k,1; mate$(12);" (";w;")"
  
  ' Passa alla riga successiva

  k = k + 1

  ' Lista equipaggio

checkequi:

  ' Se la missione è senza equipaggio va direttamente alla fine
  ' (se il volo è con equipaggio c'è sempre almeno un pilota)

  w = miss(10,x)

  IF w = 0 THEN GOTO fineriep

  ' Avanza di una riga

  k = k + 1

  PRINT AT k,1; "TRIPULACIoN:"

  k = k + 1

  ' Controlla quali sono i piloti e ne stampa il nome

  n = 10
  DO
    w = miss(n,x)
    IF w > 0 THEN PRINT AT k,3; pilo$(w): k = k + 1
    n = n + 1
  LOOP UNTIL n = 14

fineriep:

END SUB

  ' Stampa l'efficienza globale della missione. Specificare x prima di richiamare

SUB stampaeff()

  PRINT AT 18,1; "EFIC.GLOBAL: ";effmis(x);"%"

  IF z > 0 THEN PRINT AT 19,1; "(PENALIZACIoN: -";z;"%)"

END SUB

  ' Azzera i parametri della missione in caso di annullamento o di completamento

SUB azzemis()

  ' Azzera tutti i valori e torna al menù missioni.
  ' i è il numero della missione

  n = 1
  DO
    mpr(n) = 0
	miss(n,i) = 0
    n = n + 1
  LOOP UNTIL n = 17

  somma = 0

END SUB

  ' Confronta l'efficienza attuale del materiale e la relativa abilità del pilota con un numero pseudocasuale tra 1 e 100

SUB controllo()

  ' Azzera k

  k = 0

  ' Azzera il bonus abilità

  bonabi = 0

  ' Imposta il contatore

  q = 10

  ' Inserisci in z il numero del pilota dell'equipaggio

  z = mpr(q)

bonusabi:

  ' Calcola il coefficiente di salvezza per il pilota considerato e lo aggiunge a quello già determinato per gli eventuali altri membri dell'equipaggio

  ' Massimo 4 piloti per missione (10-13)

  IF q = 14 OR z = 0 THEN GOTO fasebis

  ' Abilità piloti: abi(abilità,numero pilota) (1,10)
  ' 1. PB Pilotaggio base
  ' 2. EV AEV
  ' 3. AG Aggancio
  ' 4. PA Pilotaggio avanzato; richiesta dalle missioni lunari
  ' 5. RS Resistenza (avanzata); richiesta dalle missioni lunari

  ' Abilità richiesta PB

  IF w > 3 AND w < 7 AND mpr(2) = 1 THEN y = 1

  calcbonabi()

  ' Abilità richiesta PA+RS

  IF w > 4 AND w < 11 AND mpr(2) > 1 THEN y = 4: calcbonabi(): y = 5: calcbonabi()

  ' Abilità richiesta EV

  IF w = 12 THEN y = 2: calcbonabi()

  ' Abilità richiesta AG

  IF w = 11 THEN y = 3: calcbonabi()

  ' Continua il ciclo

  q = q + 1 : GOTO bonusabi

fasebis:

  ' Determina il valore di rand tra 1 e 100

  randomBase()
  rand = randomLimit(99)+1

  ' Memorizza in q il numero della missione corrente

  q = mpr(15)

  ' Memorizza in z: efficienza attuale della missione + bonus abilità + modificatore

  z = effmis(q) + bonabi - modif
  
  ' z può arrivare al massimo a 95
  
  IF z > 95 THEN z = 95

  ' z maggiore di rand + modif: fase superata

  IF rand < z THEN BEEP .2,4: GOTO esci5

  ' Efficienza attuale della missione minore di rand: determina gravità dell'inconveniente al materiale in particolare

  k = rand - effatt(w)

esci5:

END SUB

  ' Calcola il bonus abilità (max 20)

SUB calcbonabi()

  bonabi = bonabi + INT(abi(z,y)/2)
  IF bonabi > 20 THEN bonabi = 20

END SUB

  ' Determina il tipo di inconveniente in base al materiale e stampa il relativo messaggio

SUB malfunz()

  CLS

  POKE UINTEGER indir,@malf
  stampa()

  ' La differenza tra il fattore precedentemente determinato e l'efficienza attuale del materiale considerato è memorizzata in k.
  ' Essa determina l'entità del problema

  IF k < 8 THEN prob = 1

  ' Problema serio

  IF k > 7 AND k < 15 THEN prob = 2

  ' Disastro

  IF k > 14 THEN prob = 3

  ' Stampa il messaggio relativo al materiale e alla fase

  y = y + prob

  FLASH 0: PRINT AT 3,0; pr$(y)
  BEEP 1,0
  premitasto()

  ' Determina efficienza in meno

  effatt(w) = effatt(w) - prob*20

  IF effatt(w) < 0 THEN effatt(w) = 0

  ' La ricerca e sviluppo attuale si adegua all'efficienza attuale

  rsatt(w) = effatt(w)

  ' Determina la perdita di prestigio

  prestigio = prestigio - prob*4

  ' Va alla fine se non c'è equipaggio

  IF mpr(10) = 0 THEN GOTO esci6

  ' Determina eventuali feriti o morti

  randomBase()
  rand = randomLimit(9)+1

  ' rand*prob può andare da un minimo di 1 (1*1) a un massimo di 30 (10*3)
  ' 1-10 se prob = 1 ( 1, 2, 3, 4, 5, 6, 7, 8, 9,10)
  ' 2-20 se prob = 2 ( 2, 4, 6, 8,10,12,14,16,18,20)
  ' 3-30 se prob = 3 ( 3, 6, 9,12,15,18,21,24,27,30)

  ' Determina il testo da mostrare e le conseguenze a seconda della gravità del problema e del fattore casuale.
  ' Per sapere se ci sono uno o più piloti controlliamo il valore di mpr(11), se è 0 significa che c'è un solo pilota

  rand = rand*prob

  ' 1-11 Pilota salvo
  
  IF rand < 12 AND mpr(11) = 0 THEN testo$ = "TRIPULACIoN ILESA": GOTO esci6e

  ' 1-11: Equipaggio salvo

  IF rand < 12 AND mpr(11) > 0 THEN x = mpr(10): testo$ = pilo$(x) + " ILESO": GOTO esci6e
  
  ' 12-16: Il pilota unico è ferito

  IF rand > 11 AND rand < 17 AND mpr(11) = 0 THEN x = mpr(10): piloferito(): GOTO esci6f

  ' 12-16: Un ferito nell'equipaggio

  IF rand > 11 AND rand < 17 AND mpr(11) > 0 THEN pilorand(): piloferito(): GOTO esci6f

  ' In tutti gli altri casi rand*prob va da 17 a 30

  ' Il pilota unico è morto

  IF mpr(11) = 0 THEN x = mpr(10): pilomorto(): GOTO esci6f

  ' Un morto nell'equipaggio

  IF mpr(11) > 0 THEN pilorand(): pilomorto(): GOTO esci6f

esci6e:

  ' Per determinate fasi (fase = 255) questo passaggio viene saltato, la missione fallisce senza recupero

  IF fase = 255 THEN statomis = 0 : k = 0 : GOTO esci6

  PRINT AT 6,0; testo$

  ' Chiede se continuare la missione. Possibile solo se non ci sono feriti o morti nell'equipaggio

  POKE UINTEGER indir,@continuamis
  stampa()

  ' se k = 1 continua, se k = 0 interrompi

  conferma()

  ' La missione continua

  IF k = 1 THEN POKE UINTEGER indir,@miscont: stampa(): premitasto(): GOTO esci6g

  ' Missione compromessa, impossibile continuare

esci6f:

  ' Per determinate fasi (fase = 255) questo passaggio viene saltato, la missione termina senza recupero

  IF fase = 255 THEN GOTO esci6

  ' k attualmente è posto a 0 per indicare che la missione non può continuare

  POKE UINTEGER indir,@miscompr
  stampa()

  premitasto()

  ' Ripulisce lo schermo e riprende a stampare i testi del controllo missione

esci6g:

  CLS : PRINT AT 1,6; PAPER naz; "\{i7} CONTROL DE MISIoN "

esci6:

  ' Per ultima cosa controlliamo se il mezzo è una navetta e l'entità del problema.
  ' Se il danno è serio (prob = 3) la navetta non sarà riutilizzabile al prossimo lancio

  IF mpr(1) = 7 AND prob = 3 THEN navetta = 0

END SUB

  ' Sceglie un pilota a caso e ne inserisce il numero (10-13) in q

SUB pilorand()

pilorandstart:

  randomBase()
  rand = randomLimit(3)+1

  ' rand deve essere compreso tra 1 e 4

  IF rand = 5 THEN GOTO pilorandstart

  ' q è compreso tra 10 e 13

  q = 9 + rand

  ' Se il pilota numero q è assente si ripete il ciclo

  IF mpr(q) = 0 THEN GOTO pilorandstart
  
  x = mpr(q)

END SUB

  ' Stampa il messaggio di pilota ferito e ne cambia lo status

SUB piloferito()

  PRINT AT 6,0; pilo$(x); " ESTb HERIDO!" : pilost$(x) = "L"

  ' Assegna al pilota 3 turni di cura (di fatto 2 perché la cura comincia alla fine del turno)

  abi(8,x) = 3

  ' Diminuzione del prestigio

  prestigio = prestigio - 10

END SUB

  ' Stampa il messaggio di pilota morto e ne cambia lo status

SUB pilomorto()

  PRINT AT 6,0; pilo$(x); " ESTb MUERTO!" : pilost$(x) = "X"

  ' Diminuzione del prestigio

  prestigio = prestigio - 20

END SUB

  ' Calcola e mostra il punteggio finale

SUB punteggio()

  punti = prestigio + 10*totalmis(1) + 5*totalmis(2)

  n = 1
  DO
    IF pm(n) = 1 THEN punti = punti + 30
  n = n + 1
  LOOP UNTIL n = 7

  n = 1
  DO
    IF pilost$(n) = "X" THEN punti = punti - 10
    n = n + 1
  LOOP UNTIL n = 11

  IF punti < 0 THEN punti = 0

  POKE UINTEGER indir,@puntfin
  stampa()

  PRINT AT 19,18; punti

END SUB

  ' Aumenta di 2 l'efficienza del materiale e la R&S fino al massimo possibile

SUB efficienza()

  effatt(q) = effatt(q) + 2
  rsatt(q) = rsatt(q) + 2

  IF effatt(q) > effmax(q) THEN effatt(q) = effmax(q)
  IF rsatt(q) > rsmax(q) THEN rsatt(q) = rsmax(q)
  
END SUB

  ' Stampa l'avviso "notizia flash" e controlla se gli avversari hanno raggiunto una pietra miliare

SUB notizia()

  stampa()

  POKE UINTEGER indir,@newsflash: stampa()

  IF pm(z) = 0 THEN pm(z) = 1: prestigio = prestigio - pmbon(z)/2: POKE UINTEGER indir,@pietraloro: stampa()

END SUB

  ' Cancella i piloti dalla missione in corso di programmazione

SUB cancepilo()

  n = 10
  DO
    mpr(n) = 0
    n = n + 1
  LOOP UNTIL n = 14

END SUB

  ' Stampa l'avviso "Questa missione necessita di:"

SUB necessita()

  POKE UINTEGER indir,@necedi: stampa()

END SUB

  ' Sceglie un programma di ricerca a caso

SUB progcaso()

  randomBase()
  rand = randomLimit(18)+1

END SUB

  ' Inni nazionali

SUB inno()

  IF naz = 1
    RESTORE innousa
  ELSE
    RESTORE innourss
  END IF

  n = 1
  DO
    READ alt,dur
    BEEP alt,dur
    n = n + 1
  LOOP UNTIL n = 13

innousa:

  DATA .4, 3, .1, 1, .5, -1, .5, 3, .5, 6, .9, 11
  DATA .4, 15,.1,13, .5, 11, .5, 3, .5, 5, .9,  6
  
innourss:

  DATA .4, 6, .6, 15, .4, 13, .2,11, .6, 13, .4, 10
  DATA .2, 6, .6, 11, .4, 10, .2, 8, .6, 10, .4, 3

END SUB

  ' Verifica se i piloti hanno le abilità richieste dalla missione

SUB veripilo()

  k = 0

  n = 10

check01:

  ' Prende il numero di riferimento del pilota memorizzato in mpr(n).
  ' Se il pilota è assente (y = 0) il controllo termina
  
  y = mpr(n): IF y = 0 THEN GOTO check02
  
  ' Controlla se l'abilità indicata da x è 0
  
  IF abi(x,y) = 0 THEN k = k + 1
  
  ' Aumenta il contatore per passare al pilota successivo
  
  n = n + 1

  ' Se non abbiamo finito di esaminare tutti i piloti, il ciclo si ripete
  
  IF n < 14 THEN GOTO check01

check02:

END SUB

  ' Stampa l'avviso "selezione non valida" e torna alla scelta dell'equipaggio

SUB noab()

  i = i + 1

  POKE UINTEGER indir,@noabil
  stampa()

  PRINT AT 19,0; rigav$; AT i,1; abl$(x)

END SUB

  ' Stampa la quantità di fondi a 16,1

SUB stampafondi()

  PRINT AT 16,1; INK naz; fond$; fondi

END SUB

  ' Funzioni per il calcolo dei coefficienti pseudo-casuali (Britlion, Patrik Rak)

FUNCTION FASTCALL time() AS ULONG
ASM
  DI
  LD DE,(23674)
  LD D,0
  LD HL,(23672)
  EI
END ASM
END FUNCTION

FUNCTION FASTCALL randomBase AS UBYTE
ASM
random:
  ld  de,$A280   ; xz -> yw
  ld  hl,$C0DE   ; yw -> zt
  ld  (random+1),hl  ; x = y, z = w
  ld  a,l         ; w = w ^ ( w << 3 )
  add a,a
  add a,a
  add a,a
  xor l
  ld  l,a
  ld  a,d         ; t = x ^ (x << 1)
  add a,a
  xor d
  ld  h,a
  rra             ; t = t ^ (t >> 1) ^ w
  xor h
  xor l
  ld  h,e         ; y = z
  ld  l,a         ; w = t
  ld  (random+4),hl
END ASM
END FUNCTION

SUB FASTCALL updateSeed()
REM Updates the random generator seed from the FRAMES system variable.
time()
ASM
  LD A,E
  EX DE,HL
  LD HL,random+2
  XOR (HL)
  AND A
  JR NZ,updateSeedNotZero
  INC A
updateSeedNotZero:
  LD (HL),A
  LD HL,random+4
  LD A,E
  XOR (HL)
  LD (HL),A
  INC HL
  LD A,D
  XOR (HL)
  LD (HL),A
END ASM
END SUB

FUNCTION FASTCALL randomLimit(limit AS UBYTE) AS UBYTE
ASM
  AND A
  RET Z ; Input zero, output zero.
  LD B,A ; Save A

  LD C,255
  randomBinLoop:
  RLA
  JR C, randomBinLoopExit
  RR C
  JR randomBinLoop ; loop back until we find a bit.
  randomBinLoopExit:

  randomBinRedoCall:
  call random
  AND C
  CP B
  RET Z
  JR NC, randomBinRedoCall
END ASM
END FUNCTION