  ' Ricerca e sviluppo
  ' ------------------
  
  ' Menù iniziale:
  ' 1. Satelliti/Sonde
  ' 2. Veicoli C/E
  ' 3. Moduli lunari
  ' 4. Razzi
  ' 5. Altro
  
  ' Satelliti:
  ' 1. Satellite orbita terrestre
  ' 2. Satellite orbita lunare
  ' 3. Sonda lunare
  
  ' Veicoli C/E:
  ' 1. Capsula monoposto
  ' 2. Capsula biposto
  ' 3. Capsula triposto
  ' 4. Navetta
  ' 5. Veicolo lunare
  
  ' Moduli lunari:
  ' 1. Monoposto
  ' 2. Biposto
  
  ' Razzi:
  ' 1. Leggero
  ' 2. Medio
  ' 3. Pesante
  ' 4. Super
  ' 5. Ausiliario
  
  ' Altro:
  ' 1. Modulo servizio A
  ' 2. Modulo servizio B
  ' 3. Tuta AEV
  
  ' Avvia ricerca: costoini(x) deve essere < fondi
  ' Affiancare una squadra di ricerca (1-5, 0 nessuna)?
  ' Ogni squadra di ricerca costa costors(x)
  ' Si può assegnare la ricerca solo una volta per turno
  ' Ogni squadra di ricerca dà 1-6 di effatt(x), totale mai > di rsmax(x)
  ' stru(4)=2 permette un secondo bonus 1-3
  
  BORDER 6: PAPER 5: CLS

  updateSeed()

  PRINT AT 1,6; PAPER naz; "\{i7} RICERCA E SVILUPPO "

  POKE UINTEGER indir,@menuric

  stampa()

  lista(3,1,5)
  
attesa03:

  PAUSE 0

  IF INKEY$="1" THEN GOTO ricsat
  IF INKEY$="2" THEN GOTO ricvei
  IF INKEY$="3" THEN GOTO ricmod
  IF INKEY$="4" THEN GOTO ricraz
  IF INKEY$="5" THEN GOTO ricalt
  IF INKEY$="0" THEN GOTO main
  
  GOTO attesa03

  ' Ricerca satelliti/sonde
  
ricsat:

  pulisci()
  
  w = 3
  x = 1
  
  DO
    PRINT AT w,5; mate$(x)
	w = w + 2
	x = x + 1
  LOOP UNTIL w = 9

  lista(3,1,3)

attesa04:

  PAUSE 0

  q = CODE INKEY$

  IF q < 48 OR q > 51 THEN GOTO attesa04

  IF q = 48 THEN GOTO ricerca

  x = VAL INKEY$ : GOTO avvioricerca

  ' Ricerca veicoli con equipaggio

ricvei:

  pulisci()
  
  w = 3
  x = 4
  
  DO
    PRINT AT w,5; mate$(x)
	w = w + 2
	x = x + 1
  LOOP UNTIL w = 13

  lista(3,1,5)

attesa05:

  PAUSE 0

  q = CODE INKEY$

  IF q < 48 OR q > 53 THEN GOTO attesa05

  IF q = 48 THEN GOTO ricerca

  x = VAL INKEY$ + 3: GOTO avvioricerca

  ' Ricerca moduli lunari

ricmod:

  pulisci()
  
  w = 3
  x = 9
  
  DO
    PRINT AT w,5; mate$(x)
	w = w + 2
	x = x + 1
  LOOP UNTIL w = 7

  lista(3,1,2)

attesa06:

  PAUSE 0

  q = CODE INKEY$

  IF q < 48 OR q > 50 THEN GOTO attesa06

  IF q = 48 THEN GOTO ricerca

  x = VAL INKEY$ + 8: GOTO avvioricerca

  ' Ricerca razzi
  
ricraz:

  pulisci()
  
  w = 3
  x = 13
  
  DO
    PRINT AT w,5; mate$(x)
	w = w + 2
	x = x + 1
  LOOP UNTIL w = 13

  lista(3,1,5)

attesa07:

  PAUSE 0

  q = CODE INKEY$

  IF q < 48 OR q > 53 THEN GOTO attesa07

  IF q = 48 THEN GOTO ricerca

  x = VAL INKEY$ + 12: GOTO avvioricerca

  ' Ricerca altri materiali

ricalt:

  pulisci()
  
  PRINT AT 3,5; mate$(12); AT 5,5; mate$(18); AT 7,5; mate$(19); AT 9,5; mate$(11)
  
  lista(3,1,4)

attesa08:

  PAUSE 0

  q = CODE INKEY$

  IF q < 48 OR q > 52 THEN GOTO attesa08

  IF q = 48 THEN GOTO ricerca

  IF q = 49 THEN x = 12
  IF q = 50 THEN x = 18
  IF q = 51 THEN x = 19
  IF q = 52 THEN x = 11
  
  ' Avvio ricerca materiale

avvioricerca:

  ' Se il prototipo è un ML/navetta/veicolo lunare c'è bisogno del laboratorio avanzato

  IF x > 6 AND x < 11 AND stru(1,9) = 0 THEN nostru(): GOTO ricerca

  ' Bonus per ricerca (solo capsule e razzi): se il materiale precedente è già stato ricercato al massimo,
  ' si ottiene un bonus una tantum del 20%

  ' Bonus per ricerca precedente (capsule)

  IF x > 4 AND x < 7 THEN bonusric()

  ' Bonus per ricerca precedente (razzi)

  IF x > 13 AND x < 18 THEN bonusric()

  ' Se il prototipo non è stato ancora ricercato e i fondi sono insufficienti, non è possibile avviare il programma di ricerca
  
  IF costoini(x)+costors(x) > fondi AND progrs(x) = 0 THEN nofondi() : GOTO ricerca
  
  ' Se non è possibile allocare nemmeno un tecnico, idem
  
  IF costors(x) > fondi THEN nofondi() : GOTO ricerca

  pulisci()
  
  PRINT AT 3,1; INK naz; mate$(x)
  
  costoricerca()
  
  ' Se il programma è già in corso di ricerca per questo turno, non ricercarlo di nuovo
  
  IF progrs(x) = 2 THEN POKE UINTEGER indir,@ricincorso: stampa(): premitasto(): GOTO ricerca

  ' Se non si può più andare oltre rsmax(x), torna indietro
  
  IF rsatt(x) = rsmax(x) THEN POKE UINTEGER indir,@ricalmax: stampa(): premitasto(): GOTO ricerca

sceglitecnici:

  cancerig()

  POKE UINTEGER indir,@chieditec: stampa()

  PRINT AT 19,1; ind$

  inp()
  
  IF i = 0 THEN GOTO tornaindietro
  
  IF i > 5 OR i < 1 THEN GOTO sceglitecnici
  
  PRINT AT 18,16; i; AT 19,0; rigav$
  
  ' Calcola il costo totale della ricerca. Se il programma non è stato ancora avviato inserisce anche il costo del prototipo iniziale

  w = costors(x)*i

  IF progrs(x) = 0 THEN w = w + costoini(x)
  
  ' Se il costo totale della ricerca è superiore ai fondi disponibili torna indietro,
  ' altrimenti lo sottrae dai fondi e dichiara il progetto di R&S in corso per quest'anno (progrs(x)=2)
  
  IF w > fondi THEN GOTO sceglitecnici

  ' Il numero di tecnici è caricato in y

  y = i

  ' Se è presente un centro R&S avanzato si ottiene un bonus alla ricerca di +1, come se avessimo un tecnico in più

  IF stru(1,9) = 1 THEN y = y + 1
 
  conferma()

  ' In caso di annullamento torna all'inizio

  IF k = 0 THEN GOTO ricerca
  
  ' Altrimenti sottrae l'importo della ricerca 
  
  fondi = fondi - w

  ' Se è l'inizio di un nuovo programma, costruisce il prototipo 

  IF progrs(x) = 0 THEN qt(x) = qt(x) + 1
  
  ' Il programma è in corso per questo turno
  
  progrs(x) = 2

  ' Calcolo sicurezza R&S: ogni tecnico dà un bonus da 2 a 10. Questo coefficiente viene poi aggiunto alla R&S attuale
  ' fino a che non si arriva al massimo.
  
  n = 1
  DO
    randomBase()
    rand = randomLimit(8)+2
    rsatt(x) = rsatt(x) + rand
	n = n + 1
  LOOP UNTIL n > y

  ' Massima % di ricerca per questo programma raggiunta e aumenta il prestigio di 5

  IF rsatt(x) > rsmax(x) THEN rsatt(x) = rsmax(x) : prestigio = prestigio + 5
  
  ' L'efficienza attuale è pari alla percentuale di R&S attuale
  
  effatt(x) = rsatt(x)

finericerca:

  PRINT AT 20,2; INK naz;"R&S ATTUALE: ";rsatt(x);"%"
    
  premitasto()

  GOTO ricerca

tornaindietro:

  IF x < 4 THEN GOTO ricsat
  IF x > 3 AND x < 9 THEN GOTO ricvei
  IF x = 9 OR x = 10 THEN GOTO ricmod
  IF x > 12 AND x < 18 THEN GOTO ricraz
  GOTO ricalt