  ' Gestione piloti
  ' ---------------

  ' 1. Reclutamento
  ' 2. Addestramento

  ' Ogni pilota costa 5 di reclutamento.

  ' Reclutamento: si recluta una squadra di 5 piloti per volta, max 3 volte

  ' Abilità piloti: abi(abilità,numero pilota) (1,15)
  ' 1. PCA PC Pilotaggio capsula
  ' 2. AEV EV AEV
  ' 3. AGG AG Aggancio
  ' 4. PMN PA Pilotaggio avanzato: ML/navetta/veicolo (avanzata); richiesta dalle missioni lunari
  ' 5. RES RS Resistenza a lungo termine (avanzata); richiesta dalle missioni lunari
  ' 6: Turni richiesti per l'addestramento (2 normale, 3 avanzato)
  ' 7: Abilità attualmente in addestramento (1-5)
  ' 8: Turni richiesti per la cura in caso di infortunio (2)

  ' 4 e 5 solo se stru(5) = 1

  ' Sono espresse da un numero che va da 1 a 9.
  ' 0 = abilità non addestrata.
  ' Non possono essere conosciute senza prima addestrarle.
    
  ' Status del pilota: pilost$(10)
  ' N : Non arruolato
  ' A : Disponibile (Available)
  ' T : In addestramento (Training)
  ' M : In missione
  ' I : Infortunato/ammalato
  ' X : Deceduto

  ' Scelta piloti da addestrare (max 5).
  ' Ogni pilota può essere addestrato a una sola abilità per volta

  BORDER 4: PAPER 5: CLS

  PRINT AT 1,12; PAPER naz; "\{i7} PILOTS "

  POKE UINTEGER indir,@menupilo: stampa()

  lista(3,1,3)

attesa10:

  PAUSE 0

  IF INKEY$="1" THEN GOTO reclutamento
  IF INKEY$="2" THEN GOTO addestramento
  IF INKEY$="3" THEN GOTO elencopiloti
  IF INKEY$="0" THEN GOTO main

  GOTO attesa10

reclutamento:

  CLS

  ' verifica se ci sono ancora piloti da reclutare
  
  k = 0
  
  n = 1
  DO
    IF pilost$(n) = "N" THEN k = k + 1
	n = n + 1
  LOOP UNTIL n = 11
  
  ' Non ci sono piloti da reclutare
  
  IF k = 0 THEN nopiloti(): GOTO piloti

  ' Fondi insufficienti

  IF fondi < 25 THEN nofondi(): GOTO piloti

  ' mostra l'elenco dei piloti se almeno il primo gruppo è stato reclutato

  IF pilost$(1) <> "N" THEN elenpilo()

  ' Chiede se si vuole reclutare un gruppo di 5 piloti

  stampafondi()

  POKE UINTEGER indir,@reclupilo: stampa()

  conferma()
  
  IF k = 0 THEN GOTO piloti
  
  ' Deduce i fondi
  
  fondi = fondi - 25
  
  ' Segna i piloti come disponibili a gruppi di 5, controllando i nn. 1, 6 e 11
  
  IF pilost$(1) = "N" THEN w = 1 : GOTO recluta
  IF pilost$(6) = "N" THEN w = 6

recluta:
  
  ' Recluta il primo pilota libero e i 4 successivi nell'elenco

  n = w
  DO
    pilost$(n) = "A"
	n = n + 1
  LOOP UNTIL n = w + 5

  ' Mostra il nuovo elenco dei piloti

  GOTO elencopiloti

addestramento:

  ' verifica se ci sono piloti disponibili
 
  k = 0
  
  n = 1
  DO
    IF pilost$(n) = "A" THEN k = k + 1
    n = n + 1
  LOOP UNTIL n = 11

  IF k = 0 THEN nopiloti() : GOTO piloti

  ' verifica se ci sono abbastanza fondi

  IF fondi < 5 THEN nofondi() : GOTO piloti

  elenpilo()

  stampafondi()
  
  POKE UINTEGER indir,@qualepilo: stampa()

chepilota:

  inp()

  ' Numero non valido

  IF i > 10 THEN GOTO chepilota

  ' Torna indietro

  IF i = 0 THEN GOTO piloti

  ' Pilota non disponibile

  IF pilost$(i) <> "A" THEN POKE UINTEGER indir,@pilono: stampa(): premitasto(): cancerig(): GOTO chepilota

  ' Il numero del pilota è caricato in x

  x = i

cheadd:

  CLS

  POKE UINTEGER indir,@abiaddes: stampa()

  PRINT AT 19,1; ind$; AT 1,1; INK naz; pilo$(x)
  
cheadd2:

  inp()
  
  ' Numero non valido
  
  IF i > 5 THEN GOTO cheadd2
   
  ' Torna indietro
  
  IF i = 0 THEN GOTO addestramento

  ' Addestramento non disponibile per mancanza della struttura
  
  IF i < 4 AND stru(1,4) <> 1 THEN GOTO noaddavanz
  IF i > 3 AND stru(1,5) <> 1 THEN GOTO noaddavanz
  
  ' L'abilità da addestrare è caricata in abi(7, pilota)
  
  abi(7,x) = i

  ' Abilità già al massimo

  IF abi(i,x) = 9 THEN GOTO cheadd2

  ' Il pilota viene indicato come "in addestramento"
  
  pilost$(x) = "T"

  ' Sottrae 5 dai fondi

  fondi = fondi - 5

  ' Numero di turni per l'addestramento (6, pilota): 3 = normale ; 5 = avanzato
  
  IF i < 4 THEN
    abi(6,x) = 3
  ELSE
    abi(6,x) = 5
  END IF

  premitasto()

  GOTO addestramento

elencopiloti:

  elenpilo()

  premitasto()

  GOTO piloti

  ' Struttura necessaria (addestramento avanzato)

noaddavanz:

  nostru()

  GOTO cheadd