  ' Strutture
  ' ---------

  ' stru(3,9)

  ' stru(1,x) = valore
  ' stru(2,x) = tempo di costruzione/riparazione
  ' stru(3,x) = costo

  ' 1: Rampa di lancio 1. Presente dall'inizio
  ' 2: Rampa di lancio 2. TDC: 2. Costo: 30
  ' 3: Rampa di lancio 3. TDC: 2. Costo: 30
  ' 4: Addestramento piloti base. Presente dall'inizio
  ' 5: Addestramento piloti avanzato. TDC: 4. Costo: 80
  ' 6: Assemblaggio veicoli piccoli/medi. Presente dall'inizio
  ' 7: Assemblaggio veicoli grandi. TDC: 3. Costo: 60
  ' 8: Centro R&S base. Presente dall'inizio
  ' 9: Centro R&S avanzato. TDC: 3. Costo: 70

  ' Valori rampe di lancio
  ' 0: non costruita
  ' 1: disponibile
  ' 2: occupata
  ' 3: in costruzione
  ' 4: in riparazione

  ' Valori altre strutture:
  ' 0: non costruita
  ' 1: disponibile
  ' 3: in costruzione

  BORDER 3: PAPER 5: CLS

  PRINT AT 1,10; PAPER naz; "\{i7} STRUTTURE "

  ' Stampa l'elenco delle strutture

  n = 1
  DO
    PRINT AT n+2,1; n; "."
	n = n + 1
  LOOP UNTIL n = 10

  PRINT AT 3,3; strt$(1)+"1"; AT 4,3; strt$(1)+"2"; AT 5,3; strt$(1)+"3"; AT 6,3; strt$(2)+"BASE"; AT 6,22; disp$; AT 7,3; strt$(2)+"AVANZ."; AT 8,3; strt$(3)+"P/M"; AT 8,22; disp$; AT 9,3; strt$(3)+"GRANDI"; AT 10,3; strt$(4)+"BASE"; AT 10,22; disp$; AT 11,3; strt$(4)+"AVANZ."; AT 18,1; "COSTRUIRE UNA STRUTTURA?"; AT 19,1; ind$

  stampafondi()

  ' Stampa le condizioni delle strutture

  n = 1
  DO
    IF stru(1,n) = 0 THEN PRINT AT n+2,22; INK naz; "COSTO: ";stru(3,n)
    IF stru(1,n) = 1 THEN PRINT AT n+2,22; disp$
    IF stru(1,n) = 2 THEN PRINT AT n+2,22; "OCCUPATA"
    IF stru(1,n) = 3 THEN PRINT AT n+2,22; incostr$; stru(2,n)
    IF stru(1,n) = 4 THEN PRINT AT n+2,22; "IN RIPAR."
	n = n + 1
  LOOP UNTIL n = 10

  ' Chiedi quale struttura costruire

chiedicostr:

  inp()

  IF i = 0 THEN GOTO main

  IF i > 9 THEN GOTO chiedicostr

  ' Controlla se la struttura è già stata costruita

  IF stru(1,i) <> 0 THEN GOTO chiedicostr

  ' Verifica se abbiamo fondi a sufficienza

  IF stru(3,i) > fondi THEN nofondi() : GOTO strutture

  ' Stabilisce i costi

  PRINT AT 19,1; "N.";i;" - TURNI: "; stru(2,i)

  ' Chiede conferma

  conferma()

  IF k = 0 THEN GOTO strutture

  ' In caso di conferma, scala i fondi necessari e segna la struttura come "in costruzione"

  fondi = fondi - stru(3,i): stru(1,i) = 3: GOTO strutture