  ' AD LUNAM
  ' di Alessandro Grussu, 2019

  DECLARE FUNCTION FASTCALL time() as uLong 
  DECLARE FUNCTION FASTCALL randomBase AS UBYTE
  DECLARE FUNCTION FASTCALL randomLimit(limit AS UBYTE) AS UBYTE

  ' Spazio tampone per le operazioni di stampa (v. MEMORIA.TXT)

ASM printbuffer
  NOP
  NOP
END ASM

  ' 2 byte di memoria utilizzata da stampa()

  CONST indir AS UINTEGER = 24622

  ' Carica in memoria il set di caratteri personalizzato

  POKE UINTEGER 23606,@adfont-256

  ' Disabilita ripetizione tasti

  POKE 23561,0

adlunam:

  ' Definizione variabili di base

  #INCLUDE "_0defvarb.bas"

  ' Inizializzazione variabili

  anno = 56
  turno = 1
  punti = 0
  ia = 0

  FOR n = 1 TO 8
    FOR q = 1 TO 10
      abi(n,q) = 0
    NEXT q
  NEXT n

  RESTORE strudata

  FOR n = 1 TO 3
    FOR w = 1 TO 9
      READ stru(n,w)
    NEXT w
    totalmis(n) = 0
  NEXT n

  n = 1
  DO
    pm(n) = 0
	n = n + 1
  LOOP UNTIL n = 7

  n = 1
  DO
    pilost$(n) = "N"
	n = n + 1
  LOOP UNTIL n = 11

  ' Azzeramento missioni
  
  i = 1
  DO
    azzemis()
	i = i + 1
  LOOP UNTIL i = 4

  ' ---------- SCELTA DELLA NAZIONE ----------

sceltanaz:

  BORDER 7: PAPER 7: INK 0: BRIGHT 0: CLS

  POKE UINTEGER indir,@nazione: stampa()
  
attesa01:

  PAUSE 0

  IF INKEY$="1" THEN naz = 1 : RESTORE datausa:  GOTO defin
  IF INKEY$="2" THEN naz = 2 : RESTORE dataurss: GOTO defin

  GOTO attesa01

  ' ---------- DEFINIZIONE VARIABILI SPECIFICHE ----------

defin:

  #INCLUDE "_0defvars.bas"

  ' ---------- SCELTA DELLA DIFFICOLTÀ ----------

difficolta:

  n = 9
  DO
    PRINT AT n,0; rigav$
	n = n + 1
  LOOP UNTIL n = 15

  POKE UINTEGER indir,@diffic: stampa()

attesa0:

  PAUSE 0

  IF INKEY$="1" THEN fondi = 170: prestigio = 105: prestprec = 105: cf = 1.3: modif = 0: pen = 4: GOTO main
  IF INKEY$="2" THEN fondi = 135: prestigio = 90: prestprec = 90: cf = 1.2: modif = 1: pen = 6: GOTO main
  IF INKEY$="3" THEN fondi = 100: prestigio = 75: prestprec = 75: cf = 1.1: modif = 2: pen = 8: GOTO main

  GOTO attesa0
  
  ' ---------- MENÙ PRINCIPALE ----------

main:

  BORDER 5: PAPER 6: INK 0: BRIGHT 1: CLS

  IF naz = 1 THEN
    PRINT AT 0,0; "\{p1}\{i7}w"; "\{p7}\{i2}x";CHR$ 13;"xx"
    gov$ = " PRESIDENTE "
    avver$ = "LOS SOVIgTICOS "
  ELSE
	PRINT AT 0,0; "\{p2}\{i6}y ";CHR$ 13;"  "
    gov$ = " POLITBURO "
    avver$ = "LOS AMERICANOS "
  END IF

  PRINT AT 1,3; stag$(turno);" 19";anno; AT 1,20; fond$;fondi

  x = 6: y = 4

  n = 1
  DO
    PRINT at x,y; PAPER naz; INK 7; BRIGHT 1; " ";n;" "
    x = x + 2
	n = n + 1
  LOOP UNTIL n = 9 

  POKE UINTEGER indir,@menuprin
  stampa()

attesa02:

  PAUSE 0

  IF INKEY$ = "1" THEN GOTO info
  IF INKEY$ = "2" THEN GOTO ricerca
  IF INKEY$ = "3" THEN GOTO materiali
  IF INKEY$ = "4" THEN GOTO piloti
  IF INKEY$ = "5" THEN GOTO strutture
  IF INKEY$ = "6" THEN GOTO missioni
  IF INKEY$ = "7" THEN GOTO salvacarica
  IF INKEY$ = "8" THEN GOTO fineturno

  GOTO attesa02

info:

  #INCLUDE "_1info.bas" 

ricerca:

  #INCLUDE "_2ricerca.bas"

materiali:
  
  #INCLUDE "_3materiali.bas"

piloti:

  #INCLUDE "_4piloti.bas"

strutture:

  #INCLUDE "_5strutture.bas"

missioni:

  #INCLUDE "_6missioni.bas"

salvacarica:

  #INCLUDE "_7salvacar.bas"

fineturno:

  ' ---------- AVVIO MISSIONI PIANIFICATE ----------

  #INCLUDE "_9avvio.bas"
  
  ' ---------- ATTIVITÀ DI FINE TURNO ----------

  #INCLUDE "_8fineturno.bas"

  ' ---------- VITTORIA ----------

vittoria:

  inno()

  BORDER naz: PAPER naz: INK 7: CLS

  PRINT AT 12,0; "EL";gov$;"TE LO AGRADECE."

  POKE UINTEGER indir,@messvitt

  GOTO finale

  ' ---------- SCONFITTA ----------

sconfitta:

  BORDER 0: PAPER 0: INK 7: CLS

  BEEP 1,-25

  PRINT AT 6,0; testo$; AT 1,8; INVERSE 1; " zHAS PERDIDO! "

finale:

  stampa()

  punteggio()

  premitasto()

  GOTO adlunam

  ' ---------- SOTTOPROGRAMMI ----------

  #INCLUDE "_0sottoprogrammi.bas"

  ' ---------- STRINGHE ----------

  #INCLUDE "_0stringhe.bas"
  
  ' ---------- CARATTERI PERSONALIZZATI ----------

adfont:
asm
  INCBIN "adfont.chr"
end asm